List instances
Namespace: microsoft.graph
Important
APIs under the /beta version in Microsoft Graph are subject to change. Use of these APIs in production applications is not supported. To determine whether an API is available in v1.0, use the Version selector.
Get the instances (occurrences) of an event for a specified time range.
If the event is a seriesMaster type, this returns the
occurrences and exceptions of the event in the specified time range.
Permissions
One of the following permissions is required to call this API. To learn more, including how to choose permissions, see Permissions.
| Permission type | Permissions (from least to most privileged) |
|---|---|
| Delegated (work or school account) | Calendars.Read |
| Delegated (personal Microsoft account) | Calendars.Read |
| Application | Calendars.Read |
HTTP request
GET /me/events/{id}/instances?startDateTime={start_datetime}&endDateTime={end_datetime}
GET /users/{id | userPrincipalName}/events/{id}/instances?startDateTime={start_datetime}&endDateTime={end_datetime}
GET /groups/{id}/events/{id}/instances?startDateTime={start_datetime}&endDateTime={end_datetime}
GET /me/calendar/events/{id}/instances?startDateTime={start_datetime}&endDateTime={end_datetime}
GET /users/{id | userPrincipalName}/calendar/events/{id}/instances?startDateTime={start_datetime}&endDateTime={end_datetime}
GET /groups/{id}/calendar/events/{id}/instances?startDateTime={start_datetime}&endDateTime={end_datetime}
GET /me/calendars/{id}/events/{id}/instances?startDateTime={start_datetime}&endDateTime={end_datetime}
GET /users/{id | userPrincipalName}/calendars/{id}/events/{id}/instances?startDateTime={start_datetime}&endDateTime={end_datetime}
GET /me/calendargroups/{id}/calendars/{id}/events/{id}/instances?startDateTime={start_datetime}&endDateTime={end_datetime}
GET /users/{id | userPrincipalName}/calendargroups/{id}/calendars/{id}/events/{id}/instances?startDateTime={start_datetime}&endDateTime={end_datetime}
Query parameters
In the request URL, provide the following required query parameters with values.
| Parameter | Type | Description |
|---|---|---|
| startDateTime | String | The start date and time of the time range, represented in ISO 8601 format. For example, "2015-11-08T19:00:00.0000000". |
| endDateTime | String | The end date and time of the time range, represented in ISO 8601 format. For example, "2015-11-08T20:00:00.0000000". |
This method supports the OData Query Parameters to help customize the response.
Request headers
| Name | Type | Description |
|---|---|---|
| Authorization | string | Bearer {token}. Required. |
| Prefer: outlook.timezone | string | Use this to specify the time zone for start and end times in the response. If not specified, those time values are returned in UTC. Optional. |
Request body
Do not supply a request body for this method.
Response
If successful, this method returns a 200 OK response code and collection of Event objects in the response body.
Example
Request
The following example gets within the specified time range the occurrences and exceptions of an event which is the master event of a recurring series.
GET https://graph.microsoft.com/beta/me/events/AAMkAGUzYRgWAAA=/instances?startDateTime=2019-04-08T09:00:00.0000000&endDateTime=2019-04-30T09:00:00.0000000&$select=subject,bodyPreview,seriesMasterId,type,recurrence,start,end
Response
Here is an example of the response.
HTTP/1.1 200 OK
Content-type: application/json
{
"@odata.context": "https://graph.microsoft.com/beta/$metadata#users('bb8775a4-4d8c-42cf-a1d4-4d58c2bb668f')/events('AAMkAGUzYRgWAAA%3D')/instances(subject,bodyPreview,seriesMasterId,type,recurrence,start,end)",
"value": [
{
"@odata.etag": "W/\"x3IAvB5fbUWf4XNcBFLNUwAAKuA3yQ==\"",
"id": "AAMkAGUzYAgI1sE1TatAAEYAAAAAlNFb2CNPe0ucP9you",
"subject": "Review strategy for Q3",
"bodyPreview": "Changing meeting from 4/15 to 4/16.",
"seriesMasterId": "AAMkAGUzYRgWAAA=",
"type": "exception",
"recurrence": null,
"start": {
"dateTime": "2019-04-16T20:30:00.0000000",
"timeZone": "UTC"
},
"end": {
"dateTime": "2019-04-16T21:00:00.0000000",
"timeZone": "UTC"
}
},
{
"@odata.etag": "W/\"x3IAvB5fbUWf4XNcBFLNUwAAKuA3yQ==\"",
"id": "AAMkAGUzYAgI1ru1JMcAAEYAAAAAlNFb2CNPe0ucP9you",
"subject": "Review strategy for Q3",
"bodyPreview": "",
"seriesMasterId": "AAMkAGUzYRgWAAA=",
"type": "occurrence",
"recurrence": null,
"start": {
"dateTime": "2019-04-08T20:30:00.0000000",
"timeZone": "UTC"
},
"end": {
"dateTime": "2019-04-08T21:00:00.0000000",
"timeZone": "UTC"
}
},
{
"@odata.etag": "W/\"x3IAvB5fbUWf4XNcBFLNUwAAKuA3yQ==\"",
"id": "AAMkAGUzYAgI1sa1do_AAEYAAAAAlNFb2CNPe0ucP9you",
"subject": "Review strategy for Q3",
"bodyPreview": "",
"seriesMasterId": "AAMkAGUzYRgWAAA=",
"type": "occurrence",
"recurrence": null,
"start": {
"dateTime": "2019-04-22T20:30:00.0000000",
"timeZone": "UTC"
},
"end": {
"dateTime": "2019-04-22T21:00:00.0000000",
"timeZone": "UTC"
}
},
{
"@odata.etag": "W/\"x3IAvB5fbUWf4XNcBFLNUwAAKuA3yQ==\"",
"id": "AAMkAGUzYAgI1sw1n3PAAEYAAAAAlNFb2CNPe0ucP9you",
"subject": "Review strategy for Q3",
"bodyPreview": "",
"seriesMasterId": "AAMkAGUzYRgWAAA=",
"type": "occurrence",
"recurrence": null,
"start": {
"dateTime": "2019-04-29T20:30:00.0000000",
"timeZone": "UTC"
},
"end": {
"dateTime": "2019-04-29T21:00:00.0000000",
"timeZone": "UTC"
}
}
]
}
Feedback
Submit and view feedback for